#include <stdio.h>
#include <stdlib.h>

struct {
	char ime[25+1];
	char prezime[25+1];
	char filmovi[10][50];
	int broj;
}zapis;

void main(){
	char* dat = "video.dat";
	int n, i, br;
	FILE *f;

	if((f = fopen(dat, "r+b"))==NULL){
		printf("Datoteka se ne moze otvoriti!");
		exit(1);
	}
	// odredi najveci broj zapisa
	fseek(f, 0, SEEK_END);
	br = ftell(f)/sizeof(zapis);

	printf("Unesite redni broj clana: ");
	scanf("%d", &n);
	if(n<0 || n>br){
		printf("Clan pod tim rednim brojem ne postoji!");
		exit(1);
	}
// pozicioniraj se na pocetak zapisa i ispisi informaciju o clanu
	fseek(f, (long)(n-1)*sizeof(zapis), SEEK_SET);
	fread(&zapis, (long)sizeof(zapis), 1, f);
	printf("PODACI O CLANU\n\nIme: %s", zapis.ime);
	printf("Prezime: %s", zapis.prezime);

	if(zapis.broj > 0){
		printf("Posudeni filmovi:\n");
		for(i = 1; i <= zapis.broj; i++)
			printf("%s\n", zapis.filmovi[i]);
	} else
	printf("Nema posudenih filmova.");
	fclose(f);
}
