#include <iostream.h>
#include <stdlib.h>
#include <string.h>

struct zapis{
	int god;
	char ime[25+1];
	char prez[25+1];
	struct zapis* godp;	// sljedeci zapis po starosti
	struct zapis* imep; 	// ----- II -------- imenu
	struct zapis* prezp; 	// ----- II -------- prezimenu
};

typedef struct zapis glava;

void PoGodini(glava **glavap, glava *novi) {
	for(; *glavap && (*glavap)->god < novi->god; 
		  glavap = &((*glavap)->godp));
	novi->godp = *glavap;
	*glavap = novi;
}
void PoImenu(glava **glavap, glava *novi) {
	for(;*glavap && strcmp((*glavap)->ime, novi->ime) < 0;
		 glavap = &((*glavap)->imep));
	novi->imep = *glavap;
	*glavap = novi;
}
void PoPrezimenu(glava **glavap, glava *novi) {
	for(;*glavap && strcmp((*glavap)->prez, novi->prez) < 0;
		 glavap = &((*glavap)->prezp));
	novi->prezp = *glavap;
	*glavap = novi;
}
void main(){
	int n, i;
	glava *lista_god = NULL, *lista_ime = NULL, *lista_prez = NULL;
	glava *temp;

	cout<< "Unesite broj eljenih podataka: ";
	cin>> n;
	for(i=1; i<=n; i++){
		if((temp = (glava*)malloc(sizeof(glava)))==NULL){
			cout<< "Nema dovoljno memorije!";
			return;
		}
		cout<< "Unesi ime, prezime i starost: ";
		cin>> temp->ime >> temp->prez >> temp->god;
	PoGodini(&lista_god, temp);
	PoImenu(&lista_ime, temp);
	PoPrezimenu (&lista_prez, temp);
	}
	cout<<"\nIspis po starosti:\n";
	while(lista_god){
		cout<< lista_god->god << " " << lista_god->ime << " "
		    << lista_god->prez << endl;
		lista_god = lista_god->godp;
	}
	cout<<"\nIspis po imenu:\n";
	while(lista_ime){
		cout<< lista_ime->god << " " << lista_ime->ime << " "
		    << lista_ime->prez << endl;
		lista_ime = lista_ime->imep;
	}
	cout<<"\nIspis po prezimenu:\n";
	while(lista_prez){
		cout<< lista_prez->god << " " << lista_prez->ime << " "
		    << lista_prez->prez << endl;
		lista_prez = lista_prez->prezp;
	}
}
