#include <iostream.h>
#include <stdlib.h>
// (FER, ASP - 25.4.2000)

struct zapis{
	int element;
	struct zapis* sljed;
};
typedef struct zapis glava;

// funkcija koja dodaje element na STOG realiziran listom
int dodaj(glava **vrh, int element) {
	glava *novi;
	if ((novi = (glava *) malloc(sizeof(glava))) == NULL) return 0;
	novi->element = element;
	novi->sljed = *vrh;
	*vrh = novi;
	return 1;
}

// funkcija koja skida element sa STOG-a realiziranog listom
int skini(glava **vrh, int *element) {
	glava *pom;
	if (*vrh == NULL) return 0;
	*element = (*vrh)->element;
	pom = *vrh;
	*vrh = (*vrh)->sljed;
	free (pom); // oslobodi koritenu memoriju
	return 1;
}

void main(){
	int broj;
	glava *STOG = NULL;

	while(broj){
		cin>> broj;
		if(broj)
			if(!dodaj(&STOG, broj)){
				cout<< "Nema dovoljno memorije!";
				break;
			}
	}
	while(skini(&STOG, &broj))
		cout<< broj;
}
