#include <iostream.h>

int BinTraz(int polje[], int vrijednost, int elem, int *k) {
  int prvi, zadnji, srednji;

  prvi = elem - 1;
  zadnji = 0;
  (*k) = 0;

  while (zadnji <= prvi) {
	 (*k)++;
	 srednji = (prvi + zadnji) / 2;
	 if (polje[srednji] < vrijednost)
		zadnji = srednji + 1;
	 else if (polje[srednji] > vrijednost)
		prvi = srednji - 1;
	 else
		return srednji;
  }
  return -1;
}

void Sortiraj(int polje[], int n){
	int i, j, pom;

	for(i=0; i<n-1; i++)
		for(j=0; j<n-i-1; j++)
			if(polje[j+1] < polje[j]){
				pom = polje[j+1];
				polje[j+1] = polje[j];
				polje[j] = pom;
			}
}

void main(){
	int *p, n, i, t, pokusaj = 0;

	cout<< "Unesite N: ";
	cin>> n;

	p = new int[n];	// C++ verzija
	// p = (int*)malloc(n * sizeof(int));  // C verzija

	for(i=0; i<n; i++){
		cout<< "p[" << i << "]: ";
		cin>> p[i];
	}
	Sortiraj(p, n);

	cout<< "Nakon sortiranja:\n";
	for(i=0; i<n; i++)
		cout<< p[i] << "\t";

	cout<< "\nUnesite traenu vrijednost: ";
	cin>> t;

	if(BinTraz(p, t, n, &pokusaj))
		 cout	<< "Vrijednost je pronadena nakon " << pokusaj 
			<< " pokuaja.";
	else
		cout<< "Traena vrijednost se ne nalazi u polju!";
}
